﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Collections;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  public class ClientGroupDtoList : ObservableList<ClientGroupDto>, IDeepCloneable {

    public ClientGroupDtoList() { }
    public ClientGroupDtoList(IEnumerable<ClientGroupDto> collection) {
      this.list = new List<ClientGroupDto>(collection);
    }

    [StorableConstructor]
    protected ClientGroupDtoList(bool deserializing) : base(deserializing) { }

    public object Clone() {
      return Clone(new Cloner());
    }

    public virtual IDeepCloneable Clone(Cloner cloner) {
      ClientGroupDtoList clone = (ClientGroupDtoList)Activator.CreateInstance(this.GetType());
      cloner.RegisterClonedObject(this, clone);
      clone.list = (this.Select(x => (ClientGroupDto)cloner.Clone(x))).ToList();
      return clone;
    }
  }
}
