﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.Hive.Contracts.BusinessObjects;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts {
  [StorableClass]
  public class ResponseCalendar : Response {
    [Storable]
    [DataMember]
    public bool ForceFetch { get; set; }
    [Storable]
    [DataMember]
    public IEnumerable<AppointmentDto> Appointments { get; set; }

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      ResponseCalendar clone = (ResponseCalendar) base.Clone(cloner);
      clone.Appointments = (from a in this.Appointments
                           select (AppointmentDto)cloner.Clone(a)).ToList();
      clone.ForceFetch = this.ForceFetch;
      return clone;
    }
  }
}
