using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.PluginInfrastructure;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts {
  [StorableClass]
  [DataContract]
  [Serializable]
  public class ResponsePlugin : ResponseBase {
    [Storable]
    [DataMember]
    public List<CachedHivePluginInfoDto> Plugins { get; set; }

    public ResponsePlugin() {
      Plugins = new List<CachedHivePluginInfoDto>();
    }

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      ResponsePlugin clone = (ResponsePlugin) base.Clone(cloner);
      clone.Plugins = (from p in Plugins
                       select (CachedHivePluginInfoDto)cloner.Clone(p)).ToList();
      return clone;
    }
  }
}
