﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HeuristicLab.Hive.Server {
  public partial class MainForm : Form {
    public MainForm(Dictionary<string, Uri> addresses) {
      InitializeComponent();

      Uri uri;
      StringBuilder servicesTxt = new StringBuilder();
      addresses.TryGetValue(HeuristicLabHiveServerApplication.STR_ClientCommunicator, out uri);
      if (uri != null)
        servicesTxt.AppendLine(String.Format("Server Client: {0}", uri));
      addresses.TryGetValue(HeuristicLabHiveServerApplication.STR_ServerConsoleFacade, out uri);
      if (uri != null)
        servicesTxt.AppendLine(String.Format("Server Console: {0}", uri));
      addresses.TryGetValue(HeuristicLabHiveServerApplication.STR_ExecutionEngineFacade, out uri);
      if (uri != null)
        servicesTxt.AppendLine(String.Format("Execution Engine: {0}", uri));

      rtfServices.AppendText(servicesTxt.ToString());

      ni.Icon = HeuristicLab.Common.Resources.HeuristicLab.Icon;
      ni.BalloonTipTitle = "HL Hive Server Services";
      ni.BalloonTipText = servicesTxt.ToString();
      ni.BalloonTipIcon = ToolTipIcon.Info;
      ni.Text = "HL Hive Server Services";
      ni.ShowBalloonTip(10000);
    }

    private void CloseApp(object sender, EventArgs e) {
      this.Dispose();
      Application.Exit();
    }

    private void ShowInfo(object sender, EventArgs e) {
      this.Visible = true;
    }

    private void MainForm_FormClosing(object sender, FormClosingEventArgs e) {
      e.Cancel = true;
      this.Visible = false;
    }
  }
}
